/*
 * This software is licensed under terms that can be found in the LICENSE file
 * in the root directory of this software component.
 *
 * Copyright (c) 2023, Georgy Moshkin <georgy.moshkin@outlook.com>
 * All rights reserved.
 *
 */

#ifndef __uart_h
#define __uart_h

#define UNICODE
#define _UNICODE

#include <windows.h>
#include <stdint.h>
#include <stdbool.h>

#include <iostream>
#include <string>
using namespace std;

#define COM_MAX_NUM 8

typedef struct
{
	HANDLE huartHandle;
	uint16_t timeOut;
	bool rxFail;

} COM_TPort;

bool COM_Init(uint8_t n,
        uint8_t comNum,
        DWORD bps,
		uint16_t timeOut
		);

bool COM_DeInit(uint8_t n);

HANDLE COM_GetHandle(uint8_t n);

bool COM_Write(void *pData, uint16_t Size);
bool COM_Read(void *pData, uint16_t Size);

bool sendGet(HANDLE *hPort, uint8_t *data, DWORD sendLen, DWORD needGetLen);
bool openPort(HANDLE *hPort, uint8_t pnum, DWORD bps);

#endif
